package com.loafle.overflow.crawler.mongo;

import com.loafle.overflow.crawler.Crawler;
import com.mongodb.MongoClient;
import com.mongodb.client.MongoDatabase;
import org.bson.Document;

import java.util.HashMap;
import java.util.Map;
public class MongoCrawler extends Crawler {

    protected Map<String, Object> collectMetric(String ip, String port, String dbName) {

        MongoClient mb = null;
        Map<String, Object> result = null;
        try {
            short p = Short.parseShort(port);
            mb = new MongoClient(ip, p);
            MongoDatabase database = mb.getDatabase(dbName);
            Document serverStatus = database.runCommand(new Document("serverStatus", 1));

//            System.out.println("serverStatus.size() = " + serverStatus.size());
            result = new HashMap<String, Object>(); 
            for (Map.Entry<String, Object> set : serverStatus.entrySet()){
                result.put(set.getKey(), set.getValue());
            }
        }catch (Exception e) {
            e.printStackTrace();
        }finally {
            if (mb != null) {
                mb.close();
            }
        }
        return result;
    }

    public Map<String, Object> testColect(String ip, String port, String dbName) {
        return this.collectMetric(ip,port,dbName);
    }

    @Override
    public Object getInternal(Map<String, Object> map) throws Exception {
        Map<String ,Object> re = collectMetric((String) map.get("ip"), (String)map.get("port"), (String)map.get("dbName"));
        System.out.println("re = " + re);
        return re;
    }
}